-- Zenyatta_UA
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 2/26/2017 7:14:05 PM
--------------------------------------------------------------
local iZenyatta = GameInfoTypes["CIVILIZATION_MATHALX_SHAMBALI_MONASTERY"]
local iPolicy = GameInfoTypes["POLICY_MATHALX_ZENYATTA"]
local iReformation = GameInfoTypes["POLICY_REFORMATION"]
local iUAReformation = GameInfoTypes["POLICY_ZENYATTA_REFORMATION"]
local iStronk = GameInfoTypes["IMPROVEMENT_MATHALX_ZENYATTA_STRONK_HOLY_SITE"]
local iMonk = GameInfoTypes["UNIT_MATHALX_OMNIC_MONK_ZENYATTA"]
local iCM = GameInfoTypes["BUILDING_MATHALX_COMMUNAL_MONASTERY"]

function superZenyattaForce(iPlayer, iReligion, x, y)
	local agonistes = Players[iPlayer]
	if agonistes:HasCreatedReligion() and agonistes:GetCivilizationType() == iZenyatta and agonistes:IsAlive() then
		--print("ANG")
		if not agonistes:HasPolicy(iUAReformation) and not agonistes:HasPolicy(iReformation) then
			agonistes:SetNumFreePolicies(1)
			agonistes:SetHasPolicy(iUAReformation, true)
			agonistes:SetNumFreePolicies(0)
		end
	end
end

function empowerOmnicMonk(iPlayer)
	local agonistes = Players[iPlayer]
	for taxeis in agonistes:Units() do
		if taxeis:GetUnitType() == iMonk then
			local dynamis = 12;
			local era = agonistes:GetCurrentEra();
			if (era == GameInfo.Eras["ERA_CLASSICAL"].ID) then
				dynamis = 18;
			end
			if (era == GameInfo.Eras["ERA_MEDIEVAL"].ID) then
				dynamis = 25;
			end
			if (era == GameInfo.Eras["ERA_RENAISSANCE"].ID) then
				dynamis = 32;
			end
			if (era == GameInfo.Eras["ERA_INDUSTRIAL"].ID) then
				dynamis = 45;
			end
			if (era == GameInfo.Eras["ERA_MODERN"].ID) then
				dynamis = 65;
			end
			if (era == GameInfo.Eras["ERA_POSTMODERN"].ID) then
				dynamis = 90;
			end
			if (era == GameInfo.Eras["ERA_FUTURE"].ID) then
				dynamis = 120;
			end
			if (era > GameInfo.Eras["ERA_FUTURE"].ID) then
				dynamis = 150;
			end
			taxeis:SetBaseCombatStrength(dynamis)
		end 
	end
end

GameEvents.PlayerDoTurn.Add(empowerOmnicMonk)

function empowerOmnicMonkCreation(iPlayer, iUnit)
	local agonistes = Players[iPlayer]
	if agonistes:IsEverAlive() then
		if agonistes:GetUnitByID(iUnit) ~= nil then
		local taxeis = agonistes:GetUnitByID(iUnit)
			if taxeis:GetUnitType() == iMonk then
				local dynamis = 12;
				local era = agonistes:GetCurrentEra();
				if (era == GameInfo.Eras["ERA_CLASSICAL"].ID) then
					dynamis = 18;
				end
				if (era == GameInfo.Eras["ERA_MEDIEVAL"].ID) then
					dynamis = 25;
				end
				if (era == GameInfo.Eras["ERA_RENAISSANCE"].ID) then
					dynamis = 32;
				end
				if (era == GameInfo.Eras["ERA_INDUSTRIAL"].ID) then
					dynamis = 45;
				end
				if (era == GameInfo.Eras["ERA_MODERN"].ID) then
					dynamis = 65;
				end
				if (era == GameInfo.Eras["ERA_POSTMODERN"].ID) then
					dynamis = 90;
				end
				if (era == GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 120;
				end
				if (era > GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 150;
				end
				taxeis:SetBaseCombatStrength(dynamis)
			end 
		end
	end
end

Events.SerialEventUnitCreated.Add(empowerOmnicMonkCreation)

local GPCheck = {}

function receiveGPBonusFromMonastery(iPlayer, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local agonistes = Players[iPlayer]
	local lochos = agonistes:GetUnitByID(unitID)
	if lochos:IsGreatPerson() and not GPCheck[unitID] then
		local iCulture = 0
		local iFaith = 0
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iCM) then
				iCulture = iFaith + 10 + 5 * agonistes:GetCurrentEra()
				iFaith = iFaith + 10 + 5 * agonistes:GetCurrentEra()
			end
		end
		if iCulture > 0 or iFaith > 0 then
			agonistes:ChangeJONSCulture(iCulture)
			agonistes:ChangeFaith(iFaith)
			if Game.GetActivePlayer() == iPlayer then
				Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, Locale.ConvertTextKey("TXT_KEY_MATHALX_MESSAGE_CM_GP", iCulture, iFaith), Locale.ConvertTextKey("TXT_KEY_MATHALX_MESSAGE_CM_GP_SHORT"), lochos:GetX(), lochos:GetY())
			end
		end
		GPCheck[unitID] = 1
	end
end

function adoptReformationZenyatta(playerID, policy)
	local agonistes = Players[playerID]
	if policy == iReformation and agonistes:IsAlive() and agonistes:GetCivilizationType() == iZenyatta then
		for asty in agonistes:Cities() do
			for cityPlot = 0, asty:GetNumCityPlots() - 1, 1 do
				local kleros = asty:GetCityIndexPlot(cityPlot)
				local improvementID = kleros:GetImprovementType()
				if improvementID == GameInfoTypes["IMPROVEMENT_HOLY_SITE"] and kleros:GetOwner() == playerID then
					--print("NAEGA GOJARANI")
					kleros:SetImprovementType(iStronk)
				end
			end
		end
	end
end

function checkZenyattaImprovementBuilt(klerosX, klerosY, c1, c2)	
	local kleros = Map.GetPlot(ToGridFromHex(klerosX, klerosY))
	local improvementID = kleros:GetImprovementType()
	local kektemenos = kleros:GetOwner()
	local agonistes = Players[kektemenos]
	print(kleros:GetX()..", "..kleros:GetY())
	--print(kektemenos)
	if agonistes ~= nil then
		if agonistes:GetCivilizationType() == iZenyatta then
			--print("GOJARANI2")
			if improvementID == GameInfoTypes["IMPROVEMENT_HOLY_SITE"] and agonistes:HasPolicy(iReformation) then
				print("GOJARANI3")
				kleros:SetImprovementType(iStronk)
			end
		end
	end
end

for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
	local agonistes = Players[iPlayer]
	
	if agonistes:GetCivilizationType() == iZenyatta then
		GameEvents.CityConvertsReligion.Add(superZenyattaForce)
		Events.SerialEventImprovementCreated.Add(checkZenyattaImprovementBuilt)
		GameEvents.PlayerAdoptPolicy.Add(adoptReformationZenyatta)
		if not agonistes:HasPolicy(iPolicy) then
			agonistes:SetNumFreePolicies(1)
			agonistes:SetHasPolicy(iPolicy, true)
			agonistes:SetNumFreePolicies(0)
		end
	end
end

function loadGP()
	for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local agonistes = Players[iPlayer]
		if agonistes:GetCivilizationType() == iZenyatta then
			for lochos in agonistes:Units() do
				if lochos:IsGreatPerson() and not GPCheck[lochos:GetID()] then
					GPCheck[lochos:GetID()] = 1
				end
			end
		end
	end
	Events.SerialEventUnitCreated.Add(receiveGPBonusFromMonastery)
end

Events.LoadScreenClose.Add(loadGP)