-- Zenyatta_UI
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 2/26/2017 2:32:50 AM
--------------------------------------------------------------
include("Sukritact_SaveUtils.lua"); MY_MOD_NAME = "Mathalx_Zenyatta";
include("FLuaVector.lua")
include("PlotIterators.lua")

local iZenyatta = GameInfoTypes["CIVILIZATION_MATHALX_SHAMBALI_MONASTERY"]
local iPhilosophy = GameInfoTypes["TECH_PHILOSOPHY"]
local iAirport = GameInfoTypes["BUILDING_AIRPORT"]
local iMonk = GameInfoTypes["UNIT_MATHALX_OMNIC_MONK_ZENYATTA"]
local GPCheck = {}

local iOrbOfHarmony = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_DUMMY"]
local iOrbOfHarmonyDefault = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_DEFAULT_DUMMY"]
local iOrbOfHarmonyFood = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_FOOD_DUMMY"]
local iOrbOfHarmonyProduction = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_PRODUCTION_DUMMY"]
local iOrbOfHarmonyScience = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_SCIENCE_DUMMY"]
local iOrbOfHarmonyGold = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_GOLD_DUMMY"]
local iOrbOfHarmonyCulture = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_CULTURE_DUMMY"]
local iOrbOfHarmonyFaith = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_FAITH_DUMMY"]
local iOrbOfHarmonyGreatPeople = GameInfoTypes["BUILDING_MATHALX_ORB_OF_HARMONY_GP_DUMMY"]
local iOrbOfDiscord = GameInfoTypes["BUILDING_MATHALX_ORB_OF_DISCORD_DUMMY"]

local iOrbOfHarmonyPromotion = GameInfoTypes["PROMOTION_MATHALX_ORB_OF_HARMONY"]
local iOrbOfDiscordPromotion = GameInfoTypes["PROMOTION_MATHALX_ORB_OF_DISCORD"]
local iTranscendencePromotion = GameInfoTypes["PROMOTION_MATHALX_TRANSCENDENCE"]

local lButtonDown = false
local rButtonDown = false

local iMod = ((GameInfo.GameSpeeds[Game.GetGameSpeedType()].BuildPercent)/100)
local meterMax = math.floor(2075 * iMod)

--iMode
--0 = normal
--1 = Orb of Destruction
--2 = Orb of Harmony
--3 = Orb of Discord
--4 = Transcendence
local iMode = 0;

local highlightedPlots = {};


function IsCivilisationActive(iCiv)
	for iSlot = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		local slotStatus = PreGame.GetSlotStatus(iSlot)
		if (slotStatus == SlotStatus["SS_TAKEN"] or slotStatus == SlotStatus["SS_COMPUTER"]) then
			if PreGame.GetCivilization(iSlot) == iCiv then
				return true
			end
		end
	end
	return false
end

function IsCivilizationAIActive(iCiv)
	for iSlot = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		local slotStatus = PreGame.GetSlotStatus(iSlot)
		if slotStatus == SlotStatus["SS_COMPUTER"] then
			if PreGame.GetCivilization(iSlot) == iCiv then
				return true
			end
		end
	end
	return false
end

function Goja_GetRandom(lower, upper)
    return Game.Rand((upper + 1) - lower, "") + lower
end

--Target of Ability
--[playerID][1] = Orb of Harmony Target
--[playerID][2] = Orb of Discord Target
--[playerID][3] = TranscendenceTarget
local Orbs = {}

--Ability attributes: 
--[playerID][1] = Orb of Destruction Charge
--[playerID][2] = Orb of Harmony Cooldown
--[playerID][3] = Orb of Discord Cooldown
--[playerID][4] = Transcendence Gauge
--[playerID][5] = Transcendence Turns
local Abilities = {}

local orbClass = GameInfoTypes["UNITCLASS_MATHALX_ORB_OF_DESTRUCTION_MISSILE"]
local orbDestructionTable	= {
							[GameInfoTypes.ERA_ANCIENT]			= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_01"],
							[GameInfoTypes.ERA_CLASSICAL]		= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_02"],
							[GameInfoTypes.ERA_MEDIEVAL]		= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_03"],
							[GameInfoTypes.ERA_RENAISSANCE]		= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_04"],
							[GameInfoTypes.ERA_INDUSTRIAL]		= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_05"],
							[GameInfoTypes.ERA_MODERN]			= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_06"],
							[GameInfoTypes.ERA_POSTMODERN]		= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_07"],
							[GameInfoTypes.ERA_FUTURE]			= GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_08"]
							}

local isZenyattaCivActive		= IsCivilisationActive(iZenyatta)
local isZenyattaAICivActive		= IsCivilizationAIActive(iZenyatta)

if GameInfoTypes.ERA_TRANSHUMANIST then
	print("Yer Mod is here")
	orbDestructionTable[GameInfoTypes.ERA_TRANSHUMANIST] = GameInfoTypes["UNIT_MATHALX_ORB_OF_DESTRUCTION_MISSILE_09"]
end

function updateZenyattaUI()
	local agonistes = Players[Game:GetActivePlayer()]

	if agonistes:GetCivilizationType() == iZenyatta then
		local OoDest = Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_DESTRUCTION_INFO", math.floor(Abilities[agonistes][1]/2))
		local OoH =  Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_HARMONY_INFO")
		local OoDisc = Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_DISCORD_INFO")
		local Trans = Locale.ConvertTextKey("TXT_KEY_MATHALX_TRANSCENDENCE_INFO", Abilities[agonistes][4], meterMax)

		Controls.OrbOfDestruction:SetToolTipString(OoDest)
		Controls.OrbOfHarmony:SetToolTipString(OoH)
		Controls.OrbOfDiscord:SetToolTipString(OoDisc)
		Controls.Transcendence:SetToolTipString(Trans)

		Controls.Orb_Of_Destruction_Charge:SetText(math.floor(Abilities[agonistes][1]/2))
		Controls.Orb_Of_Destruction_Charge:SetHide(false)

		if Abilities[agonistes][2] > 0 then
			Controls.Orb_Of_Harmony_Timer:SetText(Abilities[agonistes][2])
			Controls.Orb_Of_Harmony_Timer:SetHide(false)
		else
			Controls.Orb_Of_Harmony_Timer:SetHide(true)
		end

		if Abilities[agonistes][3] > 0 then
			Controls.Orb_Of_Discord_Timer:SetText(Abilities[agonistes][3])
			Controls.Orb_Of_Discord_Timer:SetHide(false)
		else
			Controls.Orb_Of_Discord_Timer:SetHide(true)
		end

		Controls.Transcendence_Gauge:SetText(math.floor(100*Abilities[agonistes][4]/meterMax) .."%")
		Controls.Transcendence_Gauge:SetHide(false)
	end
end

if isZenyattaCivActive then
	--print("Pass into the Iris")
	
	function InputHandler( uiMsg, wParam, lParam )
		if iMode ~= 0 then
			--print("ANG ANG ANG!")
			if uiMsg == MouseEvents.LButtonDown then
				lButtonDown = true
				local kleros = Map.GetPlot(UI.GetMouseOverHex())
				local agonistes = Players[Game:GetActivePlayer()]
				--print("goja plot chosen")
				if iMode == 1 then
					local limit = 0

					if kleros:IsCity() then
						local asty = kleros:GetPlotCity()
						if asty:GetOwner() == Game:GetActivePlayer() then
							if asty:IsHasBuilding(iAirport) then
								limit = 10
							else
								limit = 6
							end
						end
					else
						for taxeis in agonistes:Units() do
							if taxeis:GetUnitType() == iMonk and taxeis:AtPlot(kleros) then
								limit = 4
							end
						end
					end

					local orbs = math.floor(Abilities[agonistes][1] / 2)

					print(kleros:CountNumAirUnits(Game:GetActivePlayer()))
					if orbs > limit - kleros:CountNumAirUnits(Game:GetActivePlayer()) then
						orbs = limit - kleros:CountNumAirUnits(Game:GetActivePlayer())
					end

					if orbs > 0 then
						Abilities[agonistes][1] = Abilities[agonistes][1] - orbs * 2
						save(agonistes, "Orb_Of_Destruction_Charge", Abilities[agonistes][1])

						for goja = 1, orbs, 1 do
							for iEra, pOrb in pairs(orbDestructionTable) do
								if Players[Game:GetActivePlayer()]:GetCurrentEra() == iEra then
									Players[Game:GetActivePlayer()]:InitUnit(pOrb, kleros:GetX(), kleros:GetY(), UNITAI_MISSILE_AIR)
								end
							end
						end 

						Events.AudioPlay2DSound("AS2D_MATHALX_ORB_OF_DESTRUCTION")
						updateZenyattaUI()
					end
					iMode = 0
					Events.ClearHexHighlights()
				elseif iMode == 2 then
					if kleros:IsCity() then
						local asty = kleros:GetPlotCity()
						if asty ~= nil then
							if asty:GetOwner() == Game:GetActivePlayer() then
								for asteis in agonistes:Cities() do
									asteis:SetNumRealBuilding(iOrbOfHarmony, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyDefault, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyFood, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyProduction, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyScience, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyGold, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyCulture, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyFaith, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyGreatPeople, 0)
								end
								asty:SetNumRealBuilding(iOrbOfHarmony, 1)

								if asty:GetFocusType() == CityAIFocusTypes.NO_CITY_AI_FOCUS_TYPE then
									asty:SetNumRealBuilding(iOrbOfHarmonyDefault, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FOOD then
									asty:SetNumRealBuilding(iOrbOfHarmonyFood, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PRODUCTION then
									asty:SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD then
									asty:SetNumRealBuilding(iOrbOfHarmonyGold, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GREAT_PEOPLE then
									asty:SetNumRealBuilding(iOrbOfHarmonyGP, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_SCIENCE then
									asty:SetNumRealBuilding(iOrbOfHarmonyScience, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_CULTURE then
									asty:SetNumRealBuilding(iOrbOfHarmonyCulture, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FAITH then
									asty:SetNumRealBuilding(iOrbOfHarmonyFaith, asty:GetPopulation())
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PROD_GROWTH then
									asty:SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
								end
								if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD_GROWTH then
									asty:SetNumRealBuilding(iOrbOfHarmonyFood, 1)
								end

								for taxeis in agonistes:Units() do
									if taxeis:IsHasPromotion(iOrbOfHarmonyPromotion) then
										taxeis:SetHasPromotion(iOrbOfHarmonyPromotion, false)
									end
								end
							end
						end
						Abilities[agonistes][2] = 6
						Events.AudioPlay2DSound("AS2D_MATHALX_ORB_OF_HARMONY")
						updateZenyattaUI()
					else
						for taxeis in agonistes:Units() do
							local klerostaxeon = taxeis:GetPlot()
							taxeis:SetHasPromotion(iOrbOfHarmonyPromotion, false)
							--print(kleros:GetX()..", "..kleros:GetY().." / "..klerostaxeon:GetX()..", "..klerostaxeon:GetY())
							--print(taxeis:GetBaseCombatStrength())
							if klerostaxeon:GetX() == kleros:GetX() and klerostaxeon:GetY() == kleros:GetY() and taxeis:GetBaseCombatStrength() > 0 and taxeis:GetDomainType() ~= DomainTypes.DOMAIN_AIR then
								taxeis:SetHasPromotion(iOrbOfHarmonyPromotion, true)
								Abilities[agonistes][2] = 6
								Events.AudioPlay2DSound("AS2D_MATHALX_ORB_OF_HARMONY")
								updateZenyattaUI()
								for asteis in agonistes:Cities() do
									asteis:SetNumRealBuilding(iOrbOfHarmony, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyDefault, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyFood, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyProduction, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyScience, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyGold, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyCulture, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyFaith, 0)
									asteis:SetNumRealBuilding(iOrbOfHarmonyGreatPeople, 0)
								end
							end
						end
						--save(agonistes, "Orb_Of_Harmony_Target", kleros)
					end
					iMode = 0
					Events.ClearHexHighlights()
				elseif iMode == 3 then
					for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
						local agonistesheteros = Players[iPlayer]
						local iTeam = agonistesheteros:GetTeam()
						local bWar = Teams[Game.GetActiveTeam()]:IsAtWar(iTeam)
						if agonistesheteros ~= agonistes and bWar then
							local found = false
							for asty in agonistesheteros:Cities() do
								local klerosasteos = asty:Plot()
								if klerosasteos:GetVisibilityCount(Game:GetActiveTeam()) > 0 and klerosasteos:GetX() == kleros:GetX() and klerosasteos:GetY() == kleros:GetY() then
									found = true
									if load(agonistes, "Orb_Of_Discord_Target") ~= nil then
										if string.sub(load(agonistes, "Orb_Of_Discord_Target"), 1, 4) == "CITY" then
											local coordinates = string.sub(load(agonistes, "Orb_Of_Discord_Target"), 6)
											local x = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
											local y = string.sub(coordinates, string.find(coordinates, "_")+1)
											--print(x..", "..y)
											local klerospaleos = Map.GetPlot(x, y)
											klerospaleos:GetPlotCity():SetNumRealBuilding(iOrbOfDiscord, 0)
										else
											local id = math.floor(tonumber(string.sub(load(agonistes, "Orb_Of_Discord_Target"), 6)))
											print(id)
											local taxispaleos = agonistesheteros:GetUnitByID(id)
											taxispaleos:SetHasPromotion(iOrbOfDiscordPromotion, false)
										end
									end
									local saveString = "CITY_"..klerosasteos:GetX().."_"..klerosasteos:GetY()
									print(saveString)
									save(agonistes, "Orb_Of_Discord_Target", saveString)
									
									asty:SetNumRealBuilding(iOrbOfDiscord, 1)

									Abilities[agonistes][3] = 6
									Events.AudioPlay2DSound("AS2D_MATHALX_ORB_OF_DISCORD")
									updateZenyattaUI()
									--Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(asty:GetX(), asty:GetY())), true, Vector4(1.0, 0, 0, 1.0));
								end
							end
							if not found then
								for taxeis in agonistesheteros:Units() do
									local klerostaxeon = taxeis:GetPlot()
									if klerostaxeon:GetVisibilityCount(Game:GetActiveTeam()) > 0 and not found and klerostaxeon:GetX() == kleros:GetX() and klerostaxeon:GetY() == kleros:GetY() and taxeis:GetBaseCombatStrength() > 0 and taxeis:GetDomainType() ~= DomainTypes.DOMAIN_AIR then
										found = true
										if load(agonistes, "Orb_Of_Discord_Target") ~= nil then
											if string.sub(load(agonistes, "Orb_Of_Discord_Target"), 1, 4) == "CITY" then
												local coordinates = string.sub(load(agonistes, "Orb_Of_Discord_Target"), 6)
												local x = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
												local y = string.sub(coordinates, string.find(coordinates, "_")+1)
												--print(x..", "..y)
												local klerospaleos = Map.GetPlot(x, y)
												klerospaleos:GetPlotCity():SetNumRealBuilding(iOrbOfDiscord, 0)
											else
												local id = math.floor(tonumber(string.sub(load(agonistesheteros, "Orb_Of_Discord_Target"), 6)))
												local taxispaleos = agonistesheteros:GetUnitByID(id)
												taxispaleos:SetHasPromotion(iOrbOfDiscordPromotion, false)
											end
										end

										local saveString = "UNIT_"..taxeis:GetID()
										print(saveString)
										save(agonistes, "Orb_Of_Discord_Target", saveString)
										taxeis:SetHasPromotion(iOrbOfDiscordPromotion, true)

										Abilities[agonistes][3] = 6
										Events.AudioPlay2DSound("AS2D_MATHALX_ORB_OF_DISCORD")
										updateZenyattaUI()
										--Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(taxeis:GetX(), taxeis:GetY())), true, Vector4(1.0, 0, 0, 1.0));
									end
								end
							end
						end
					end
					iMode = 0
					Events.ClearHexHighlights()
				elseif iMode == 4 then
					if kleros:IsCity() then
						local asty = kleros:GetPlotCity()
						if asty ~= nil then
							if asty:GetOwner() == Game:GetActivePlayer() then
								local saveString = "COORD_"..kleros:GetX().."_"..kleros:GetY()
								--print(saveString)
								save(agonistes, "Transcendence_Target", saveString)

								for taxeis in agonistes:Units() do
									if taxeis:IsHasPromotion(iTranscendencePromotion) then
										taxeis:SetHasPromotion(iTranscendencePromotion, false)
									end
								end
							end
						end
						Abilities[agonistes][4] = 0
						Orbs[agonistes][3] = 3
						save(agonistes, "Trascendence_Turns", Orbs[agonistes][3])
						Events.AudioPlay2DSound("AS2D_MATHALX_TRANSCENDENCE")
						updateZenyattaUI()
					else
						for taxeis in agonistes:Units() do
							local found = false
							local klerostaxeon = taxeis:GetPlot()
							taxeis:SetHasPromotion(iOrbOfHarmonyPromotion, false)
							--print(kleros:GetX()..", "..kleros:GetY().." / "..klerostaxeon:GetX()..", "..klerostaxeon:GetY())
							--print(taxeis:GetBaseCombatStrength())
							if klerostaxeon:GetX() == kleros:GetX() and klerostaxeon:GetY() == kleros:GetY() and (taxeis:IsGreatPerson() or taxeis:GetUnitType() == iMonk) and not found then
								found = true
								local saveString = "COORD_"..klerostaxeon:GetX().."_"..klerostaxeon:GetY()
								--print(saveString)
								save(agonistes, "Transcendence_Target", saveString)
								
								taxeis:SetHasPromotion(iTranscendencePromotion, true)
								Abilities[agonistes][4] = 0
								Orbs[agonistes][3] = 3
								save(agonistes, "Trascendence_Turns", Orbs[agonistes][3])
								Events.AudioPlay2DSound("AS2D_MATHALX_TRANSCENDENCE")
								updateZenyattaUI()
							end
						end
						--save(agonistes, "Orb_Of_Harmony_Target", kleros)
					end
					iMode = 0
					Events.ClearHexHighlights()
				end
			elseif uiMsg == MouseEvents.LButtonUp then
				if lButtonDown then
					lButtonDown = false
				end
			elseif uiMsg == MouseEvents.RButtonDown then
				rButtonDown = true
			elseif uiMsg == MouseEvents.RButtonUp then
				if rButtonDown and iMode > 0 then
					rButtonDown = false
					iMode = 0
					Events.ClearHexHighlights()
				end
			end
		end
		return false;
	end
	ContextPtr:SetInputHandler( InputHandler )

	function pressOrbOfDestruction()
		local agonistes = Players[Game:GetActivePlayer()]
		if math.floor(Abilities[agonistes][1] / 2) > 0 then
			iMode = 1
			for asty in agonistes:Cities() do
				local kleros = asty:Plot()
				if kleros:CountNumAirUnits(Game:GetActivePlayer()) < 6 or (kleros:CountNumAirUnits(Game:GetActivePlayer()) < 10 and asty:IsHasBuilding(iAirport)) then
					Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(asty:GetX(), asty:GetY())), true, Vector4(1.0, 1.0, 0, 1.0))
				end
			end
			for taxeis in agonistes:Units() do
				local kleros = taxeis:GetPlot()
				if taxeis:GetUnitType() == iMonk and kleros:CountNumAirUnits(Game:GetActivePlayer()) < 4 then
					Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(taxeis:GetX(), taxeis:GetY())), true, Vector4(1.0, 1.0, 0, 1.0))
				end
			end
			--print("GOJA MODE")
		end
	end
	Controls.OrbOfDestruction:RegisterCallback(Mouse.eLClick, 
	function()
		pressOrbOfDestruction()
	end
	)

	function AIOrbOfDestruction(iPlayer)
		local agonistes = Players[iPlayer]
		--local kleros = nil
		if agonistes:IsAlive() and agonistes:GetCivilizationType() == iZenyatta and not agonistes:IsHuman() then
			print(Abilities[agonistes][1])
			if Abilities[agonistes][1] >= 8 and Teams[agonistes:GetTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) then
				local sphyrai = {}
				local kleroi = {}
				local size = 0
				for taxeis in agonistes:Units() do
					if taxeis:GetUnitClassType() == orbClass then
						if sphyrai[taxeis:GetPlot()] ~= nil then
							sphyrai[taxeis:GetPlot()] = sphyrai[taxeis:GetPlot()] + 1
						else
							sphyrai[taxeis:GetPlot()] = 1
						end
					elseif taxeis:GetUnitType() == iMonk then
						size = size + 1
						kleroi[size] = taxeis:GetPlot()
						if sphyrai[taxeis:GetPlot()] == nil then
							sphyrai[taxeis:GetPlot()] = 0
						end
						--print("ADD MONK")
					end
				end
				for asty in agonistes:Cities() do
					size = size + 1
					kleroi[size] = asty:Plot()
					if sphyrai[asty:Plot()] == nil then
						sphyrai[asty:Plot()] = 0
					end
					--print("ADD CITY")
				end
				print(size)
				local kleroidoxioi = {}
				local newsize = 0
				for goja = 1, size, 1 do
					--print("CHECK")
					if sphyrai[kleroi[goja]] ~= nil then
						--print("ANG")
						if sphyrai[kleroi[goja]] < 4 then
							--print("GOJARANI")
							newsize = newsize + 1
							kleroidoxioi[newsize] = kleroi[goja]
						end
					end
				end
				print(newsize)
				local kleros = kleroidoxioi[Goja_GetRandom(1, newsize)]
				print(kleros:GetX() ..","..kleros:GetY())
				local orbs = math.floor(Abilities[agonistes][1] / 2)

				if orbs > 4 - sphyrai[kleros] then
					orbs = sphyrai[kleros]
				end

				if orbs > 0 then
					Abilities[agonistes][1] = Abilities[agonistes][1] - orbs * 2
					save(agonistes, "Orb_Of_Destruction_Charge", Abilities[agonistes][1])

					for gojaang = 1, orbs, 1 do
						for iEra, pOrb in pairs(orbDestructionTable) do
							if agonistes:GetCurrentEra() == iEra then
								agonistes:InitUnit(pOrb, kleros:GetX(), kleros:GetY(), UNITAI_MISSILE_AIR)
							end
						end
					end 
				end
			end
		end
	end

	function pressOrbOfHarmony()
		local agonistes = Players[Game:GetActivePlayer()]
		if Abilities[agonistes][2] <= 0 then
			iMode = 2
			for asty in agonistes:Cities() do
				local kleros = asty:Plot()
				Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(asty:GetX(), asty:GetY())), true, Vector4(1.0, 1.0, 0, 1.0))
			end
			for taxeis in agonistes:Units() do
				Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(taxeis:GetX(), taxeis:GetY())), true, Vector4(1.0, 1.0, 0, 1.0))
			end
		end
	end
	Controls.OrbOfHarmony:RegisterCallback(Mouse.eLClick, 
	function()
		pressOrbOfHarmony()
	end
	)

	function AIOrbOfHarmony(iPlayer)
		local agonistes = Players[iPlayer]
		if agonistes:IsAlive() and agonistes:GetCivilizationType() == iZenyatta and not agonistes:IsHuman() then
			if Abilities[agonistes][2] <= 0 and Teams[agonistes:GetTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) then
				--Simple: Use on capital
				if agonistes:GetCapitalCity() ~= nil then
					for asteis in agonistes:Cities() do
						asteis:SetNumRealBuilding(iOrbOfHarmony, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyDefault, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyFood, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyProduction, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyScience, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyGold, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyCulture, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyFaith, 0)
						asteis:SetNumRealBuilding(iOrbOfHarmonyGreatPeople, 0)
					end
					agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmony, 1)

					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.NO_CITY_AI_FOCUS_TYPE then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyDefault, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FOOD then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyFood, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PRODUCTION then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyGold, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GREAT_PEOPLE then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyGP, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_SCIENCE then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyScience, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_CULTURE then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyCulture, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FAITH then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyFaith, asty:GetPopulation())
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PROD_GROWTH then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
					end
					if agonistes:GetCapitalCity():GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD_GROWTH then
						agonistes:GetCapitalCity():SetNumRealBuilding(iOrbOfHarmonyFood, 1)
					end

					for taxeis in agonistes:Units() do
						if taxeis:IsHasPromotion(iOrbOfHarmonyPromotion) then
							taxeis:SetHasPromotion(iOrbOfHarmonyPromotion, false)
						end
					end
				end
				Abilities[agonistes][2] = 6
			end
		end
	end

	function pressOrbOfDiscord()
		local size = 0
		local agonistes = Players[Game:GetActivePlayer()]
		if Abilities[agonistes][3] <= 0 then
			for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
				local agonistesheteros = Players[iPlayer]
				local iTeam = agonistesheteros:GetTeam()
				local bWar = Teams[Game.GetActiveTeam()]:IsAtWar(iTeam)
				if agonistesheteros ~= agonistes and bWar then
					for taxeis in agonistesheteros:Units() do
						local kleros = taxeis:GetPlot()
						--print(kleros:GetVisibilityCount(Game:GetActiveTeam()))
						if kleros:GetVisibilityCount(Game:GetActiveTeam()) > 0 then
							size = size + 1
							Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(taxeis:GetX(), taxeis:GetY())), true, Vector4(1.0, 0, 0, 1.0))
						end
					end
					for asty in agonistesheteros:Cities() do
						local kleros = asty:Plot()
						--print(kleros:GetVisibilityCount(Game:GetActiveTeam()))
						if kleros:GetVisibilityCount(Game:GetActiveTeam()) > 0 then
							size = size + 1
							Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(asty:GetX(), asty:GetY())), true, Vector4(1.0, 0, 0, 1.0))
						end
					end
				end
			end
			if size > 0 then
				iMode = 3
			end
		end
	end
	Controls.OrbOfDiscord:RegisterCallback(Mouse.eLClick, 
	function()
		pressOrbOfDiscord()
	end
	)

	function pressTranscendence()
		local agonistes = Players[Game:GetActivePlayer()]
		if Abilities[agonistes][4] >= meterMax then
			iMode = 4
			for asty in agonistes:Cities() do
				local kleros = asty:Plot()
				Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(asty:GetX(), asty:GetY())), true, Vector4(0, 1.0, 1.0, 1.0))
			end
			for taxeis in agonistes:Units() do
				if taxeis:IsGreatPerson() or taxeis:GetUnitType() == iMonk then
					Events.SerialEventHexHighlight(ToHexFromGrid(Vector2(taxeis:GetX(), taxeis:GetY())), true, Vector4(0, 1.0, 1.0, 1.0))
				end
			end
		end
	end
	Controls.Transcendence:RegisterCallback(Mouse.eLClick, 
	function()
		pressTranscendence()
	end
	)

	function updateOrbs(iPlayer)
		local agonistes = Players[iPlayer]
		if agonistes:IsEverAlive() and agonistes:GetCivilizationType() == iZenyatta and Teams[agonistes:GetTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) then
			--Units
			for taxeis in agonistes:Units() do
				if taxeis:IsHasPromotion(iOrbOfHarmonyPromotion) then
					Abilities[agonistes][4] = Abilities[agonistes][4] + 25
				end
			end

			--Cooldown
			if Abilities[agonistes][1] < 9 then
				Abilities[agonistes][1] = Abilities[agonistes][1] + 1
				save(agonistes, "Orb_Of_Destruction_Charge", Abilities[agonistes][1])
			end

			if Abilities[agonistes][2] > 0 then
				Abilities[agonistes][2] = Abilities[agonistes][2] - 1
				save(agonistes, "Orb_Of_Harmony_Cool", Abilities[agonistes][2])
			end

			if Abilities[agonistes][3] > 0 then
				Abilities[agonistes][3] = Abilities[agonistes][3] - 1
				save(agonistes, "Orb_Of_Discord_Cool", Abilities[agonistes][3])
			end

			Abilities[agonistes][4] = Abilities[agonistes][4] + agonistes:GetTotalFaithPerTurn()
			if Abilities[agonistes][4] > meterMax then
				Abilities[agonistes][4] = meterMax
			end
			save(agonistes, "Transcendence_Meter", Abilities[agonistes][4])
			
			if Orbs[agonistes][3] > 0 then
				Orbs[agonistes][3] = Orbs[agonistes][3] - 1
				if Game.GetActivePlayer() == iPlayer then
					local coordinates = string.sub(load(agonistes, "Transcendence_Target"), 7)
					local tx = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
					local ty = string.sub(coordinates, string.find(coordinates, "_")+1)

					Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, Locale.ConvertTextKey("TXT_KEY_MATHALX_MESSAGE_TRANSCENDENCE_TURNS_LEFT", Orbs[agonistes][3]), Locale.ConvertTextKey("TXT_KEY_MATHALX_MESSAGE_TRANSCENDENCE_SHORT"), tx, ty)
				end
			else
				for taxeis in agonistes:Units() do
					if taxeis:IsHasPromotion(iTranscendencePromotion) then
						taxeis:SetHasPromotion(iTranscendencePromotion, false)
					end
				end
			end

			updateZenyattaUI()

			--Debug for test
			--local proteuousa = Players[Game:GetActivePlayer()]:GetCapitalCity()
			--if proteuousa ~= nil then
			--	print("GetRevealedTeam:"..proteuousa:Plot():GetRevealedTeam(Game:GetActiveTeam()))
			--	print("GetVisibilityCount":..proteuousa:Plot():GetVisibilityCount(Game:GetActiveTeam()))
			--end
		end
		if Teams[Game:GetActiveTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) and Players[Game:GetActivePlayer()]:GetCivilizationType() == iZenyatta then
			Controls.DaOrbs:SetHide(false)
		end
		for asty in agonistes:Cities() do
			if asty:GetNumBuilding(iOrbOfHarmony) > 0 then
				asty:SetNumRealBuilding(iOrbOfHarmonyDefault, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyFood, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyProduction, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyScience, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyGold, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyCulture, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyFaith, 0)
				asty:SetNumRealBuilding(iOrbOfHarmonyGreatPeople, 0)

				if asty:GetFocusType() == CityAIFocusTypes.NO_CITY_AI_FOCUS_TYPE then
					asty:SetNumRealBuilding(iOrbOfHarmonyDefault, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FOOD then
					asty:SetNumRealBuilding(iOrbOfHarmonyFood, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PRODUCTION then
					asty:SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD then
					asty:SetNumRealBuilding(iOrbOfHarmonyGold, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GREAT_PEOPLE then
					asty:SetNumRealBuilding(iOrbOfHarmonyGP, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_SCIENCE then
					asty:SetNumRealBuilding(iOrbOfHarmonyScience, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_CULTURE then
					asty:SetNumRealBuilding(iOrbOfHarmonyCulture, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_FAITH then
					asty:SetNumRealBuilding(iOrbOfHarmonyFaith, asty:GetPopulation())
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_PROD_GROWTH then
					asty:SetNumRealBuilding(iOrbOfHarmonyProduction, 1)
				end
				if asty:GetFocusType() == CityAIFocusTypes.CITY_AI_FOCUS_TYPE_GOLD_GROWTH then
					asty:SetNumRealBuilding(iOrbOfHarmonyFood, 1)
				end

				Abilities[agonistes][4] = Abilities[agonistes][4] + 5
				save(agonistes, "Transcendence_Meter", Abilities[agonistes][4])
				updateZenyattaUI()
			end
			if asty:GetNumBuilding(iOrbOfDiscord) > 0 then
				asty:ChangeResistanceTurns(1)
			end
		end
		for kPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
			local agonistesheteros = Players[kPlayer]
			local kleroskatadesmou = nil
			if load(agonistesheteros, "Orb_Of_Discord_Target") ~= nil then
				print(load(agonistesheteros, "Orb_Of_Discord_Target"))
				if string.sub(load(agonistesheteros, "Orb_Of_Discord_Target"), 1, 4) == "CITY" then
					local coordinates = string.sub(load(agonistesheteros, "Orb_Of_Discord_Target"), 6)
					local x = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
					local y = string.sub(coordinates, string.find(coordinates, "_")+1)
					--print(x..", "..y)
					
					kleroskatadesmou = Map.GetPlot(x, y)
					local astypalea = kleroskatadesmou:GetPlotCity()
					print(astypalea:GetName())
					if astypalea == nil then
						save(agonistesheteros, "Orb_Of_Discord_Target", nil)
						kleroskatadesmou = nil
					elseif astypalea:GetNumBuilding(iOrbOfDiscord) <= 0 then
						save(agonistesheteros, "Orb_Of_Discord_Target", nil)
						kleroskatadesmou = nil
					else
						if agonistes == agonistesheteros then
							Abilities[agonistesheteros][4] = Abilities[agonistesheteros][4] + 10
							if Abilities[agonistesheteros][4] > meterMax then
								Abilities[agonistesheteros][4] = meterMax
							end
							save(agonistesheteros, "Transcendence_Meter", Abilities[agonistesheteros][4])
							updateZenyattaUI()
						end
					end
				else
					local id = string.sub(load(agonistesheteros, "Orb_Of_Discord_Target"), 6)
					print(id)
					local taxispaleos = agonistesheteros:GetUnitByID(id)
					if taxispaleos ~= nil then
						kleroskatadesmou = taxispaleos:GetPlot()
						if Abilities[agonistesheteros][4] > meterMax then
							Abilities[agonistesheteros][4] = meterMax
						end
						if agonistesheteros == agonistes then
							Abilities[agonistesheteros][4] = Abilities[agonistesheteros][4] + 20
							save(agonistesheteros, "Transcendence_Meter", Abilities[agonistesheteros][4])
							updateZenyattaUI()
						end
					else
						save(agonistesheteros, "Orb_Of_Discord_Target", nil)
					end
				end
			end
			--Orb of Discord Disable Air units
			if kleroskatadesmou ~= nil then
				for taxeis in agonistes:Units() do
					if taxeis:GetDomainType() == DomainTypes.DOMAIN_AIR then
						local klerostaxeon = taxeis:GetPlot()
						if klerostaxeon:GetX() == kleroskatadesmou:GetX() and klerostaxeon:GetY() == kleroskatadesmou:GetY() then
							taxeis:SetMoves(0)
						end
					end
				end
			end
			--Transcendence
			
			if load(agonistesheteros, "Transcendence_Target") ~= nil and Orbs[agonistesheteros][3] > 0 then
				print(load(agonistesheteros, "Transcendence_Target"))
				local coordinates = string.sub(load(agonistesheteros, "Transcendence_Target"), 7)
				local tx = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
				local ty = string.sub(coordinates, string.find(coordinates, "_")+1)
				--print("Transcendence Target is: "..tx..", "..ty)
				local klerosmagikos = Map.GetPlot(tx, ty)
				for taxeis in agonistesheteros:Units() do
					--print(taxeis:GetPlot():GetX()..", "..taxeis:GetPlot():GetY())
					print(Map.PlotDistance(taxeis:GetPlot():GetX(), taxeis:GetPlot():GetY(), klerosmagikos:GetX(), klerosmagikos:GetY()))
					if klerosmagikos:IsCity() then
						if Map.PlotDistance(taxeis:GetPlot():GetX(), taxeis:GetPlot():GetY(), klerosmagikos:GetX(), klerosmagikos:GetY()) <= 3 then
							taxeis:ChangeDamage(-100, agonistesheteros:GetID())
						end
					else
						if Map.PlotDistance(taxeis:GetPlot():GetX(), taxeis:GetPlot():GetY(), klerosmagikos:GetX(), klerosmagikos:GetY()) <= 2 then
							taxeis:ChangeDamage(-100, agonistesheteros:GetID())
						end
					end
				end
			end
		end
	end
	GameEvents.PlayerDoTurn.Add(updateOrbs)

	function unlockPhilosophy(iTeam, iTech, change)
		if iTech == GameInfo.Technologies["TECH_PHILOSOPHY"].ID and iTeam == Game:GetActiveTeam() then
			local agonistes = Players[Game:GetActivePlayer()]
			local OoDest = Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_DESTRUCTION_INFO", Abilities[agonistes][1])
			local OoH =  Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_HARMONY_INFO")
			local OoDisc = Locale.ConvertTextKey("TXT_KEY_MATHALX_ORB_OF_DISCORD_INFO")
			local Trans = Locale.ConvertTextKey("TXT_KEY_MATHALX_TRANSCENDENCE_INFO", Abilities[agonistes][4], meterMax)

			Controls.OrbOfDestruction:SetToolTipString(OoDest)
			Controls.OrbOfHarmony:SetToolTipString(OoH)
			Controls.OrbOfDiscord:SetToolTipString(OoDisc)
			Controls.Transcendence:SetToolTipString(Trans)
		end
	end

	function moveOrb(playerID, unitID, x, y)
		local agonistes = Players[playerID]
		local taxeis = agonistes:GetUnitByID(unitID)
		if taxeis:IsHasPromotion(iTranscendencePromotion) then
			local klerostaxeon = taxeis:GetPlot()
			local saveString = "COORD_"..klerostaxeon:GetX().."_"..klerostaxeon:GetY()
			--print(saveString)
			save(agonistes, "Transcendence_Target", saveString)
		end
	end
	GameEvents.UnitSetXY.Add(moveOrb)

	GameEvents.TeamTechResearched.Add(unlockPhilosophy)

	function receiveUltimateFromGP(iPlayer, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
		local agonistes = Players[iPlayer]
		local lochos = agonistes:GetUnitByID(unitID)
		if lochos:IsGreatPerson() and not GPCheck[unitID] and agonistes:GetCivilizationType() == iZenyatta then
			Abilities[agonistes][4] = Abilities[agonistes][4] + 500
			if Abilities[agonistes][4] > meterMax then
				Abilities[agonistes][4] = meterMax
			end
			updateZenyattaUI()
			GPCheck[unitID] = 1
		end
	end

	Events.SerialEventUnitCreated.Add(receiveUltimateFromGP)

	function endZenyattaWar(iTeam1, iTeam2, bWar)
		if not bWar then
			for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
				local agonistes = Players[iPlayer]
				if agonistes:GetTeam() == iTeam1 or agonistes:GetTeam() == iTeam2 then
					if load(agonistes, "Orb_Of_Discord_Target") ~= nil then
						if string.sub(load(agonistes, "Orb_Of_Discord_Target"), 1, 4) == "CITY" then
							local coordinates = string.sub(load(agonistes, "Orb_Of_Discord_Target"), 6)
							local x = string.sub(coordinates, 1, string.find(coordinates, "_")-1)
							local y = string.sub(coordinates, string.find(coordinates, "_")+1)
							kleroskatadesmou = Map.GetPlot(x, y)
							local astypalea = kleroskatadesmou:GetPlotCity()
							for jPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
								if astypalea:GetOwner() == jPlayer then
									astypalea:SetNumRealBuilding(iOrbOfDiscord, 0)
									save(agonistes, "Orb_Of_Discord_Target", nil)
								end
							end
						else
							local id = math.floor(tonumber(string.sub(load(agonistes, "Orb_Of_Discord_Target"), 6)))
							for kPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
								local agonistesheteros = Players[kPlayer]
								if agonistesheteros:GetUnitByID(id) ~= nil then
									agonistesheteros:GetUnitByID(id)SetHasPromotion(iOrbOfDiscordPromotion, false)
									save(agonistes, "Orb_Of_Discord_Target", nil)
								end
							end
						end
					end
				end
			end
		end
	end
	Events.WarStateChanged.Add(endZenyattaWar)
end

function OnEnterCityScreen()
	Controls.DaOrbs:SetHide(true)
end

function OnExitCityScreen()
	if Teams[Game:GetActiveTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) and Players[Game:GetActivePlayer()]:GetCivilizationType() == iZenyatta then
		Controls.DaOrbs:SetHide(false)
		updateZenyattaUI()
	end
end

if isZenyattaCivActive then
	Events.SerialEventExitCityScreen.Add( OnExitCityScreen )
	Events.SerialEventEnterCityScreen.Add( OnEnterCityScreen )
else
	Controls.DaOrbs:SetHide(true)
end

if isZenyattaAICivActive then
	GameEvents.PlayerDoTurn.Add(AIOrbOfDestruction)
	GameEvents.PlayerDoTurn.Add(AIOrbOfHarmony)
end

for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
	local agonistes = Players[iPlayer]
	Abilities[agonistes] = {}
	Orbs[agonistes] = {}
	if agonistes:GetCivilizationType() == iZenyatta then
		if load(agonistes, "Orb_Of_Destruction_Charge") == nil then
			Abilities[agonistes][1] = 0
			save(agonistes, "Orb_Of_Destruction_Charge", 0)
		else
			Abilities[agonistes][1] = load(agonistes, "Orb_Of_Destruction_Charge")
		end
		if load(agonistes, "Orb_Of_Harmony_Cool") == nil then
			Abilities[agonistes][2] = 0
			save(agonistes, "Orb_Of_Harmony_Cool", 0)
		else
			Abilities[agonistes][2] = load(agonistes, "Orb_Of_Harmony_Cool")
		end
		if load(agonistes, "Orb_Of_Discord_Cool") == nil then
			Abilities[agonistes][3] = 0
			save(agonistes, "Orb_Of_Discord_Cool", 0)
		else
			Abilities[agonistes][3] = load(agonistes, "Orb_Of_Discord_Cool")
		end
		if load(agonistes, "Transcendence_Meter") == nil then
			Abilities[agonistes][4] = 0
			save(agonistes, "Transcendence_Meter", 0)
		else
			Abilities[agonistes][4] = load(agonistes, "Transcendence_Meter")
		end
		if load(agonistes, "Transcendence_Turns") == nil then
			Orbs[agonistes][3] = 0
			save(agonistes, "Transcendence_Turns", 0)
		else
			Orbs[agonistes][3] = load(agonistes, "Transcendence_Turns")
		end
	end
	if not Teams[Game:GetActiveTeam()]:IsHasTech(GameInfo.Technologies[iPhilosophy].ID) or Players[Game:GetActivePlayer()]:GetCivilizationType() ~= iZenyatta then
		Controls.DaOrbs:SetHide(true)
	else
		updateZenyattaUI()
	end
end